﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DefineSHP
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnSHP_Click(object sender, EventArgs e)
        {
            DialogResult DR = saveFileDialog.ShowDialog();
            if (DR == DialogResult.OK)
            {
                String FileName = saveFileDialog.FileName;
                tbSHP.Text = FileName;
            }
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            FieldDefineForm form = new FieldDefineForm();
            form.cbType.SelectedIndex = 0;
            DialogResult DR = form.ShowDialog();
            if (DR == DialogResult.OK)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = form.tbFieldName.Text;
                lvi.SubItems.Add(form.cbType.Text);
                lvi.SubItems.Add(form.nudLength.Value.ToString());
                lvi.SubItems.Add(form.nudDecimal.Value.ToString());

                lvFields.Items.Add(lvi);
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (lvFields.SelectedIndices.Count == 1)
            {
                int SelectIndex = lvFields.SelectedIndices[0];
                lvFields.Items.RemoveAt(SelectIndex);
            }
        }

        private void btnModify_Click(object sender, EventArgs e)
        {
            if (lvFields.SelectedIndices.Count == 1)
            {
                FieldDefineForm form = new FieldDefineForm();

                int SelectIndex = lvFields.SelectedIndices[0];
                ListViewItem item = lvFields.Items[SelectIndex];

                form.tbFieldName.Text = item.Text;
                form.cbType.Text = item.SubItems[1].Text;
                form.nudLength.Value = Int16.Parse(item.SubItems[2].Text);
                form.nudDecimal.Value = Int16.Parse(item.SubItems[3].Text);

                DialogResult DR = form.ShowDialog();
                if (DR == DialogResult.OK)
                {
                    item.Text = form.tbFieldName.Text;
                    item.SubItems[1].Text = form.cbType.Text;
                    item.SubItems[2].Text = form.nudLength.Value.ToString();
                    item.SubItems[3].Text = form.nudDecimal.Value.ToString();
                }
            }
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            int cntFields = lvFields.Items.Count;
            XrMapLib.FieldSetDefine FSD = new XrMapLib.FieldSetDefine();

            for (int iField = 0; iField < cntFields; ++iField)
            {
                ListViewItem fieldItem = lvFields.Items[iField];
                String FieldName = fieldItem.Text;
                String FieldType = fieldItem.SubItems[1].Text;
                int Length = Int16.Parse(fieldItem.SubItems[2].Text);
                int Decimal = Int16.Parse(fieldItem.SubItems[3].Text);

                if (FieldType.CompareTo("String") == 0)
                {
                    FSD.AddStringField(FieldName, Length);
                }
                else if (FieldType.CompareTo("Float") == 0)
                {
                    FSD.AddFloatField(FieldName, Length, Decimal);
                }
                else if (FieldType.CompareTo("Integer") == 0)
                {
                    FSD.AddIntegerField(FieldName, Length);
                }
            }

            XrMapLib.XrShapeTypeEnum ShapeType = XrMapLib.XrShapeTypeEnum.XrPoint;
            String strShapeType = cbShapeType.Text;
            if (strShapeType.CompareTo("Polyline") == 0)
            {
                ShapeType = XrMapLib.XrShapeTypeEnum.XrPolyline;
            }
            else if (strShapeType.CompareTo("Polygon") == 0)
            {
                ShapeType = XrMapLib.XrShapeTypeEnum.XrPolygon;
            }

            String FileNameSHP = tbSHP.Text;
            XrMapLib.Tool tool = new XrMapLib.Tool();
            XrMapLib.EsriShpFileHandler SFH = tool.CreateEsriShpFileHandler(FileNameSHP, ShapeType, FSD);
            if (FileNameSHP.Length == 0 || SFH == null)
            {
                MessageBox.Show("Error: Creating shp file");
                return;
            }

            Close();
        }
    }
}
